// Tcp.h

/* Author:  Marty Kraimer Date:    09APR1998 */
 
/*************************************************************************
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory, and the Regents of the University of California, as
* Operator of Los Alamos National Laboratory. MPF is distributed
* subject to a Software License Agreement found in file LICENSE that
* is included with this distribution.
*************************************************************************/
#ifndef TcpH
#define TcpH

enum tcpConnectState {tcpConnectYes, tcpConnectNo};
typedef void(*tcpConnectCallback)(void *pvt,tcpConnectState state);
typedef void(*tcpReceiveCallback)(void *pvt,void *buffer,int32 nbytes);

class Tcp
{
public:
    Tcp(bool isServer,int port,const char *address,int bufferSize);
    ~Tcp();
    void connect(void *userPvt, tcpConnectCallback ,tcpReceiveCallback);
    int send(void *data,int32 size);
    int flush();
    int sendFlush(void *data,int32 size);
    void printStats();
private:
    void *tcpPvt;
    // disallow following
    Tcp();
    Tcp(const Tcp &);
    Tcp& operator=(const Tcp&);
};

#endif /* TcpH */
