// Float64Message.h
/*************************************************************************
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory, and the Regents of the University of California, as
* Operator of Los Alamos National Laboratory. MPF is distributed
* subject to a Software License Agreement found in file LICENSE that
* is included with this distribution.
*************************************************************************/

#ifndef Float64MessageH
#define Float64MessageH

#include "Message.h"
#include "StandardFieldsMessage.h"
class DLList;

class Float64Message : public StandardFieldsMessage
{
public:
    Float64Message();
    virtual ~Float64Message() {}
    virtual int32  toBuffer(char **buffer) const;
    virtual int32  fromBuffer(const char **buffer);
    virtual int32  fromBufferSwitch(const char **buffer);
    virtual void print() const;
    static void *operator new(size_t size);
    void operator delete(void *p, size_t size);
    //following are for use by client/server
    float64 value;
protected:
    Float64Message(messageType type);
private:
    static DLList *pFreeList;
    // Disallow copy constructor, assignment operator 
    Float64Message(const Float64Message&);
    Float64Message& operator=(const Float64Message&);
};

#endif /*Float64MessageH*/
